Subject: bug#21319: `package-install-file' fails with CRLF (Windows) line endings

From: Eli Zaretskii <[email-masked]>
Date: Fri, 29 Nov 2019 15:29:55 +0200

> From: Stefan Kangas <[email-masked]>
> Date: Fri, 29 Nov 2019 13:58:15 +0100
> Cc: [email-masked]
> 
> >> (defun package-install-file (file)
> >>   "Install a package from a file.
> >> The file can either be a tar file or an Emacs Lisp file."
> >>   (interactive "fPackage file name: ")
> >>   (with-temp-buffer
> >>     (insert-file-contents-literally file)
> >>     (when (string-match "\\.tar\\'" file) (tar-mode))
> >>     (package-install-from-buffer)))
> >>
> >> Since `insert-file-contents-literally' does not do any conversion
> >> `package-buffer-info' fails to parse the info if the file is .el and
> >> contains CRLF line endings. It then errors out with:
> >>
> >> Debugger entered--Lisp error: (error "Package lacks a \"Version\" or
> >> \"Package-Version\" header")
> >>   signal(error ("Package lacks a \"Version\" or \"Package-Version\" header"))
> >>   error("Package lacks a \"Version\" or \"Package-Version\" header")
> >>   package-buffer-info()
> >>
> >> This affects all recent Emacs versions (including trunk).
> >
> > This was reported 4 years ago, but unfortunately never got a reply at
> > the time.
> >
> > Are you still seeing this on a recent version of Emacs?  If yes, could
> > you please provide a minimal example file which fails to install?

The code is still there.  One can see if the problem happens by making
a package that is a single .el file with CRLF EOL format.

> > Also, why does your file have these line endings in the first place?
> > Was this file written in Emacs?  I'm trying to understand if this is
> > an important use case or the common scenario for users of MS-Windows,
> > since I don't use it myself.

When a file is created on MS-Windows, even if it's a .el file, its EOL
format is by default identical to that of the underlying platform's
defaults.  On MS-Windows, you will get CRLF, yes.

> Does anyone think it's important to support CRLF line endings in
> package.el?

I don't know if this is important, but then fix is trivial: use
insert-file-contents after binding coding-system-for-read to raw-text.

> I don't use Windows, so I'm not sure that I understand if
> this is an important use case or not.  But AFAIK, and this might be
> completely wrong, you should be fine as long as you edit the file in
> Emacs?

AFAIU, the problem is that one cannot install such a package, because
the current code signals an error.